<?php
//ini_set('display_errors', 1);
// ini_set('display_startup_errors', 1);
 //error_reporting(E_ALL);
include("config.php");
if (array_key_exists('HTTP_ORIGIN', $_SERVER)) {
    $origin = $_SERVER['HTTP_ORIGIN'];
} else if (array_key_exists('HTTP_REFERER', $_SERVER)) {
    $origin = $_SERVER['HTTP_REFERER'];
} else {
    $origin = $_SERVER['REMOTE_ADDR'];
}
$GLOBALS['origin']=$origin;


if (!empty($_SERVER['HTTP_CLIENT_IP']))
  {
    $ip_address = $_SERVER['HTTP_CLIENT_IP'];
  }
//whether ip is from proxy
elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
  {
    $ip_address = $_SERVER['HTTP_X_FORWARDED_FOR'];
  }
//whether ip is from remote address
else
  {
    $ip_address = $_SERVER['REMOTE_ADDR'];
  }
$GLOBALS['ipaddress']= $ip_address;

session_start();


/* code to fetch location from third party
$json     = file_get_contents("http://ipinfo.io/$origin/geo");
$json     = json_decode($json, true);
$country  = $json['country'];
$region   = $json['region'];
$city     = $json['city'];*/

//echo $GLOBALS['origin'] ;




if (!isset($_SESSION)) {
    if (strpos($_SERVER['HTTP_HOST'], '104.211.141.35:8080') !== false) {
        session_set_cookie_params(0, '/', '104.211.141.35:8080');
    }else{
       session_set_cookie_params(0, '/', 'localhost');
    }
    session_start();
}


if (isset($_SESSION['last_activity']) && (time() - $_SESSION['last_activity'] >3600)) {
    // last request was more than 60 minutes ago
    session_unset();     // unset $_SESSION variable for the run-time
    session_destroy();   // destroy session data in storage
}
$_SESSION['last_activity'] = time();
 // update last activity time stamp
 
require_once 'UserModel.php';



class PortalApi extends UserModel {
	
    private $user_model;

    public function __construct() {
        parent::__construct();  
		 
        // Init parent contructor
       $this->user_model = new UserModel();
    }

    /*
     * Public method for access api.
     * This method dynmically call the method based on the query string
    */

    public function processApi() {
		
		$func = strtolower(trim(str_replace("/", "", $_REQUEST['run'])));
		  $this->_request = json_decode(file_get_contents('php://input'), true);
		$this->$func();
		
    }

    /*
     * 	Simple login API
     *  Login must be POST method
     *  email : <USER EMAIL>
     */

    private function login() {
                if ($this->get_request_method() != "POST") {
                    $error = array("status_code" => 0,"status" => "Failed", "code" => 406, "msg" => "Not Acceptable.");
                    $this->response($this->json($error), 406);
                }
                $password = $userID='';
                if (isset($this->_request['email'])) {
                    $userID = $this->_request['email'];
                }
                if (isset($this->_request['password'])) {
                    $password = $this->_request['password'];
                }
                if (!empty($userID) && !empty($password) ) {
                    $this->checklogin($userID, $password,$GLOBALS['ipaddress']);
                } else {
                    $error = array("status_code" => 0,'status' => "Failed", "msg" => "Invalid Request Parameters.");
                    $this->response($this->json($error), 406);
                }
            }
			
     private function lovhead() {
		
		 $request=$this->_request;
		 //$this->lovheaddb($token,$request);
		 
		 
        // Cross validation if the request method is POST else it will return "Not Acceptable" status
        if ($this->get_request_method() != "POST") {
            $error = array("status_code" => 0,"status" => "Failed", "code" => 406, "msg" => "Not Acceptable.");
            $this->response($this->json($error), 406);
        }
        
		$token=$this->getToken();
		
        // Input validations
		
		$this->lovheaddb($this->_request);
				
       if($token==$_SESSION['token']) {
		       
            $this->lovheaddb($token,$this->_request);
        } else {
            $error = array("status_code" => 0,'status' => "Failed", "msg" => "Invalid Token.");
            $this->response($this->json($error), 401);
        }
    }
	
	 private function lovline() {
		
		 $request=$this->_request;
		// $this->lovlinedb($token,$request);
		 
        // Cross validation if the request method is POST else it will return "Not Acceptable" status
        if ($this->get_request_method() != "POST") {
            $error = array("status_code" => 0,"status" => "Failed", "code" => 406, "msg" => "Not Acceptable.");
            $this->response($this->json($error), 406);
        }
        
		$token=$this->getToken();
		
		 $this->lovlinedb($request);
		
        // Input validations
       // if($token==$_SESSION['token']) {
		   
		    // $this->lovlinedb($token,$request);
            
        // } else {
            // $error = array("status_code" => 0,'status' => "Failed", "msg" => "Invalid Token.");
            // $this->response($this->json($error), 401);
        // }
    }
	
	private function addUser() {
		
		 $request=$this->_request;
		 

        // Cross validation if the request method is POST else it will return "Not Acceptable" status
        if ($this->get_request_method() != "POST") {
            $error = array("status_code" => 0,"status" => "Failed", "code" => 406, "msg" => "Not Acceptable.");
            $this->response($this->json($error), 406);
        }
        
		$token=$this->getToken();
		$this->addUserDb($request);
		
		
        // Input validations
       if($token==$_SESSION['token']) {
		  
           $this->addUserDb($token,$request);
        } else {
            $error = array("status_code" => 0,'status' => "Failed", "msg" => "Invalid Token.");
            $this->response($this->json($error), 401);
        }
    }
	
	private function addAccess() {
		
		 $request=$this->_request;
		
        // Cross validation if the request method is POST else it will return "Not Acceptable" status
        if ($this->get_request_method() != "POST") {
            $error = array("status_code" => 0,"status" => "Failed", "code" => 406, "msg" => "Not Acceptable.");
            $this->response($this->json($error), 406);
        }
        
		$token=$this->getToken();
		$this->addAccessDB($request);
		
        // Input validations
       if($token==$_SESSION['token']) {
		   
		     
             $this->addAccessDB($token,$request);
        } else {
            $error = array("status_code" => 0,'status' => "Failed", "msg" => "Invalid Token.");
            $this->response($this->json($error), 401);
        }
    }
	
	private function branches() {
		
		 $request=$this->_request;
		
        // Cross validation if the request method is POST else it will return "Not Acceptable" status
        if ($this->get_request_method() != "POST") {
            $error = array("status_code" => 0,"status" => "Failed", "code" => 406, "msg" => "Not Acceptable.");
            $this->response($this->json($error), 406);
        }
        
		$token=$this->getToken();
		$this->getBranchesAll($request);
		
        // Input validations
       if($token==$_SESSION['token']) {
		   
             $this->getBranchesAll($token,$request);
			 
        } else {
            $error = array("status_code" => 0,'status' => "Failed", "msg" => "Invalid Token.");
            $this->response($this->json($error), 401);
        }
    }
	
	private function journals() {
		
		 $request=$this->_request;
		
        // Cross validation if the request method is POST else it will return "Not Acceptable" status
        if ($this->get_request_method() != "POST") {
            $error = array("status_code" => 0,"status" => "Failed", "code" => 406, "msg" => "Not Acceptable.");
            $this->response($this->json($error), 406);
        }
        
		$token=$this->getToken();
		
		$this->getJournalsAll($request);
		
        // Input validations
       if($token==$_SESSION['token']) {
		   
             //$this->getJournalsAll($token,$request);
			 
        } else {
            $error = array("status_code" => 0,'status' => "Failed", "msg" => "Invalid Token.");
            $this->response($this->json($error), 401);
        }
    }


    private function accountSetup() {
		
        $request=$this->_request;
       
       // Cross validation if the request method is POST else it will return "Not Acceptable" status
       if ($this->get_request_method() != "POST") {
           $error = array("status_code" => 0,"status" => "Failed", "code" => 406, "msg" => "Not Acceptable.");
           $this->response($this->json($error), 406);
       }
       
       $token=$this->getToken();
       
       $this->getaccountSetup($request);
       
       // Input validations
      if($token==$_SESSION['token']) {
          
            //$this->getaccountSetup($token,$request);
            
       } else {
           $error = array("status_code" => 0,'status' => "Failed", "msg" => "Invalid Token.");
           $this->response($this->json($error), 401);
       }
   }

   private function commission() {
		
    $request=$this->_request;
   
   // Cross validation if the request method is POST else it will return "Not Acceptable" status
   if ($this->get_request_method() != "POST") {
       $error = array("status_code" => 0,"status" => "Failed", "code" => 406, "msg" => "Not Acceptable.");
       $this->response($this->json($error), 406);
   }
   
   $token=$this->getToken();
   
   $this->getcommission($request);
   
   // Input validations
  if($token==$_SESSION['token']) {
      
        //$this->getcommission($token,$request);
        
   } else {
       $error = array("status_code" => 0,'status' => "Failed", "msg" => "Invalid Token.");
       $this->response($this->json($error), 401);
   }
}

private function settings() {
		
    $request=$this->_request;
   
   // Cross validation if the request method is POST else it will return "Not Acceptable" status
   if ($this->get_request_method() != "POST") {
       $error = array("status_code" => 0,"status" => "Failed", "code" => 406, "msg" => "Not Acceptable.");
       $this->response($this->json($error), 406);
   }
   
   $token=$this->getToken();
   
   $this->getSettings($request);
   
   // Input validations
  if($token==$_SESSION['token']) {
      
        //$this->getSettings($token,$request);
        
   } else {
       $error = array("status_code" => 0,'status' => "Failed", "msg" => "Invalid Token.");
       $this->response($this->json($error), 401);
   }
}


    private function verifySession() {
        $status = "Success";
        $msg = "Already logged-in.";
        if (isset($_SESSION)) {
            if (!isset($_SESSION['userID'])) {
                $status = "Failed";
                $msg = "No session maintained.";
            }
        } else {
            $status = "Failed";
            $msg = "No session maintained.";
        }
        $error = array("status_code" => 0,'status' => $status, "msg" => $msg);
        $this->response($this->json($error), 401);
    }

	private function getToken()
	 {
			foreach (getallheaders() as $name => $value) {
		//echo "$name: $value\n";

		if($name=='token')
		{
			$user_token=  str_replace("Bearer ","",$value);

		}
			}

			return $user_token;
	 }

    private function logout() {
        // Cross validation if the request method is POST else it will return "Not Acceptable" status
     if ($this->get_request_method() != "GET") {
            $error = array("status" => "Failed", "code" => 406, "msg" => "Not Acceptable.");
            $this->response($this->json($error), 406);
        }

        $this->logoutUser();
    }

}

// Initiiate Library
$api = new PortalApi;
$api->processApi();
