<?php
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST, GET, PUT, DELETE, OPTIONS');
header('Access-Control-Allow-Headers: origin, x-requested-with, Origin, X-Requested-With, Content-Type, Access-Control-Allow-Origin, X-Token, x-token, withCredentials, withcredentials,Authorization');
header('Access-Control-Allow-Credentials: true');
//require 'phpmailer/PHPMailerAutoload.php';
class UserModel
{
    public $data = "";
    private $db = NULL;
    public $_allow = array();
    public $_content_type = "application/json";
    public $_request = array();
    private $_method = "";
    private $_code = 200;
    private $dbhost = '';
    private $dbusername = '';
    private $dbpassword = '';
    private $dbName = '';
    public function __construct()
    {
        //  require_once __DIR__.'/../Globals/config.php';
        $this->inputs();
        $this->dbhost     = 'localhost';
        $this->dbusername = 'kaladisfa';
        $this->dbpassword = 'Kaladi@2020';
        $this->dbName     = 'berar_finance';
        //$this->dbName = 'supplier_portal_prod1';
        //$this->upload_folder_name = $GLOBALS['uploads_folder'];
        $this->dbConnect(); // Initiate Database connection
        date_default_timezone_set('UTC');
        mysqli_set_charset($this->db, "UTF8");
    }
    /*
     *  Database connection
     */
    private function dbConnect()
    {
        $this->db = mysqli_connect($this->dbhost, $this->dbusername, $this->dbpassword, $this->dbName);
        if (!$this->db) {
            $error_log = array(
                "status_code" => 0,
                'status' => "Failed",
                "msg" => "Internal Server Error.",
                "additional" => "Database Login failed! Please make sure that the DB login credentials provided are correct"
            );
            log_info($this->json($error_log));
            $error = array(
                'status' => "Failed",
                "msg" => "Internal Server Error."
            );
            $this->response($this->json($error), 200);
        }
    }
    public function get_referer()
    {
        return $_SERVER['HTTP_REFERER'];
    }
    public function response($data, $status)
    {
        $this->_code = ($status) ? $status : 200;
        $this->set_headers();
        echo $data;
        exit;
    }
    private function get_status_message()
    {
        $status = array(
            100 => 'Continue',
            101 => 'Switching Protocols',
            200 => 'OK',
            201 => 'Created',
            202 => 'Accepted',
            203 => 'Non-Authoritative Information',
            204 => 'No Content',
            205 => 'Reset Content',
            206 => 'Partial Content',
            300 => 'Multiple Choices',
            301 => 'Moved Permanently',
            302 => 'Found',
            303 => 'See Other',
            304 => 'Not Modified',
            305 => 'Use Proxy',
            306 => '(Unused)',
            307 => 'Temporary Redirect',
            400 => 'Bad Request',
            401 => 'Unauthorized',
            402 => 'Payment Required',
            403 => 'Forbidden',
            404 => 'Not Found',
            405 => 'Method Not Allowed',
            406 => 'Not Acceptable',
            407 => 'Proxy Authentication Required',
            408 => 'Request Timeout',
            409 => 'Conflict',
            410 => 'Gone',
            411 => 'Length Required',
            412 => 'Precondition Failed',
            413 => 'Request Entity Too Large',
            414 => 'Request-URI Too Long',
            415 => 'Unsupported Media Type',
            416 => 'Requested Range Not Satisfiable',
            417 => 'Expectation Failed',
            500 => 'Internal Server Error',
            501 => 'Not Implemented',
            502 => 'Bad Gateway',
            503 => 'Service Unavailable',
            504 => 'Gateway Timeout',
            505 => 'HTTP Version Not Supported'
        );
        return ($status[$this->_code]) ? $status[$this->_code] : $status[500];
    }
    public function get_request_method()
    {
        return $_SERVER['REQUEST_METHOD'];
    }
    private function inputs()
    {
        switch ($this->get_request_method()) {
            case "OPTIONS":
                $this->response('', 200);
                break;
            case "POST":
                $this->_request = $this->cleanInputs($_REQUEST);
                break;
            case "GET":
            case "DELETE":
                $this->_request = $this->cleanInputs($_GET);
                break;
            case "PUT":
                parse_str(file_get_contents("php://input"), $this->_request);
                $this->_request = $this->cleanInputs($this->_request);
                break;
            default:
                $this->response('', 406);
                break;
        }
    }
    private function cleanInputs($data)
    {
        $clean_input = array();
        if (is_array($data)) {
            foreach ($data as $k => $v) {
                $clean_input[$k] = $this->cleanInputs($v);
            }
        } else {
            // if (get_magic_quotes_gpc()) {
            //     $data = trim(stripslashes($data));
            // }
            $data        = strip_tags($data);
            $clean_input = trim($data);
        }
        return $clean_input;
    }
    private function set_headers()
    {
        header("HTTP/1.1 " . $this->_code . " " . $this->get_status_message());
        header("Content-Type:" . $this->_content_type);
        //header('Access-Control-Allow-Origin: '.$GLOBALS['origin']);
        //header('Access-Control-Allow-Origin:http://localhost:4200');
        header('Access-Control-Allow-Origin: *');
        header('Access-Control-Allow-Methods: POST, GET, PUT, DELETE, OPTIONS');
        header('Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Access-Control-Allow-Origin, X-Token, x-token, withCredentials, withcredentials,');
        header('Access-Control-Allow-Credentials: true');
    }
    /*
     * 	Encode array into JSON
     */
    public function json($data)
    {
        if (is_array($data)) {
            return json_encode($data);
        }
    }
    /* login functionality using email_id */
    protected function checklogin($userID, $pswd, $origin)
    {
        $password = md5($pswd);
        $sql      = sprintf("SELECT employeeName,userID,recordID,employeeID,(select lovValues from XXBERAR_LOV_TYPE where lovHeadID=2 and recordID=XXBERAR_USER_SETUP.subRole limit 1)subRoleName from XXBERAR_USER_SETUP where userID='%s' and password='%s' limit 0,1", mysqli_real_escape_string($this->db, $userID), mysqli_real_escape_string($this->db, $password));
        $result   = mysqli_query($this->db, $sql);
        if (!$result) {
            $error_log = array(
                "status_code" => 0,
                'status' => "Failed",
                "msg" => "Internal Server Error.",
                "query" => "$sql"
            );
            //log_info($this->json($error_log));
            $error     = array(
                "status_code" => 0,
                'status' => "Failed",
                "msg" => "Internal Server Error.(login)"
            );
            $this->response($this->json($error), 200);
        } else {
            $num_of_rows = mysqli_num_rows($result);
            if ($num_of_rows > 0) {
                while ($row = mysqli_fetch_array($result)) {
                    $user_id                           = $row['userID'];
                    $name                              = $row['employeeName'];
                    $recordID                          = $row['recordID'];
                    $employeeID                        = $row['employeeID'];
                    $subRoleName                        = $row['subRoleName'];
                    $row                               = array_map('utf8_encode', $row);
                    $output['user'][0]['user_id']      = $user_id;
                    $output['user'][0]['employeeName'] = $name;
                    $output['user'][0]['recordID']     = $recordID;
                    $output['user'][0]['employeeID']   = $employeeID;
                    $output['user'][0]['subRoleName']   = $subRoleName;
                }
                $_SESSION['recordID']=$recordID;
                //$_SESSION['recordID'] = '8';
                $_SESSION['userID']   = $user_id;
                //    $_SESSION['pwd'] = $pwd;
                $_SESSION['token']    = md5(uniqid($userID, true));

                $session_id=$_SESSION['recordID'];

              $sql_access = sprintf("SELECT xua.recordID, xar.subRoleID,(select lovValues from XXBERAR_LOV_TYPE where lovHeadID=2 and recordID=xua.subRole limit 1)subRoleName,(SELECT lovValues
				FROM XXBERAR_LOV_TYPE
				WHERE recordID = xar.privilegeID
				)lovValues,xar.managerAccess as previlage
				From XXBERAR_USER_SETUP xua, XXBERAR_ACCESS_RIGHTS xar
				Where
					 xar.subRoleID= xua.subRole
				 and xua.recordID='$session_id'");
				 
	
						$result_acesss = mysqli_query($this->db, $sql_access);
						while ($row_chk = mysqli_fetch_assoc($result_acesss)) {
							$row_acess = array_map('utf8_encode', $row_chk);
							$output_result[] = $row_acess;
						}
											
						$output['access']=$output_result;

                        //branch value get

                        $sql_branch = sprintf("SELECT branchName from XXBERAR_USER_SETUP_LINE where userRecordID='$recordID'");
				
						$result_branch = mysqli_query($this->db, $sql_branch);
						while ($row_chk = mysqli_fetch_assoc($result_branch)) {
							$row_branch = array_map('utf8_encode', $row_chk);
							$output_branch[] = $row_branch;
						}
											
						$output['branch']=$output_branch;


                $session_log   = array(
                    'status' => "Session",
                    "msg" => $_SESSION['userID'],
                    "token" => $_SESSION['token']
                );
                $out    = array(
                    "status_code" => 1,
                    'status' => true,
                    'msg' => 'Success',
                    "token" => $_SESSION['token'],
                    'result' => $output
                );
                $this->response($this->json($out), 200);
            } else {
                $error = array(
                    "status_code" => 0,
                    'status' => "Login Failed",
                    "msg" => "We could not find that account. Incorrect email and / or password"
                );
                $this->response($this->json($error), 401);
            }
        }
    }
    protected function lovheaddb($request)
    {
        $sql         = sprintf("SELECT recordID,lovHeader,description from XXBERAR_LOV_HEAD where enabled = '1' order by lovHeader asc");
        $result      = mysqli_query($this->db, $sql);
        $num_of_rows = mysqli_num_rows($result);
        if ($num_of_rows > 0) {
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
        } else {
            $output = array();
        }
        $out = array(
            "status_code" => 1,
            'status' => "Success",
            'msg' => "Lov Head",
            'result' => $output
        );
        $this->response($this->json($out), 200);
    }
    protected function lovlinedb($request)
    {
        $lovType        = $request['lovType'];
        $lovSetUp       = $request['lovSetUp'];
        $flag           = $request['flag'];
        $session_prev   = $_SESSION['recordID'];
        $subRoleID      = $_SESSION['subRole'];
        $previlege_find = "select previlage from (SELECT xua.recordID, xar.subRoleID, xar.privilegeID,(SELECT lovValues
				FROM XXTATA_SP_LOV_TYPE
				WHERE recordID = xar.privilegeID
				)lovValues,xua.managerPrivilege,xua.buyerPrivilege,xua.adminPrivilege, 
				greatest(CASE WHEN(xua.managerPrivilege = 1) THEN xar.managerAccess ELSE 0 END,
						 CASE WHEN(xua.buyerPrivilege = 1) THEN xar.buyerAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 1) THEN xar.adminAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 0 and xua.buyerPrivilege = 0 and xua.managerPrivilege = 0) THEN xar.	noPrivilegeAccess ELSE 0 END) previlage
				From XXTATA_SP_USER_SETUP xua, XXTATA_SP_ACCESS_RIGHTS xar
				Where
					 xar.subRoleID= xua.subRole
				 and xua.recordID='$session_prev')f where f.lovValues='ADMIN'";
        //echo $previlege_find;
        $result_find    = mysqli_query($this->db, $previlege_find);
        while ($row = mysqli_fetch_array($result_find)) {
            $row       = array_map('utf8_encode', $row);
            $previlage = $row['previlage'];
        }
        if ($flag == 1) // creation of lov head
            {
            foreach ($lovSetUp as $item) {
                $lovValues   = $item['lovValues'];
                $description = $item['description'];
                $status      = $item['status'];
                $recordID    = $item['recordID'];
                if ($recordID == '') {
					if($lovValues !='' || $description !=''){
						 $sql    = sprintf("insert into XXBERAR_LOV_TYPE(lovheadID,lovValues,description,status,createdBY)VALUES ('%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $lovType), mysqli_real_escape_string($this->db, $lovValues), mysqli_real_escape_string($this->db, $description), mysqli_real_escape_string($this->db, $status), mysqli_real_escape_string($this->db, $session_prev));
						$result = mysqli_query($this->db, $sql);
					}
                } else {
                     $sql    = sprintf("update XXBERAR_LOV_TYPE set lovheadID='$lovType',lovValues='$lovValues',description='$description',status='$status',lastupdateDate=now(),lastupdateBy='$session_prev' where recordID='$recordID'", mysqli_real_escape_string($this->db, $recordID));
                    $result = mysqli_query($this->db, $sql);
                }
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => "Created Successfully",
                'result' => "[]"
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 3) // selection of lov line
            {
            $lovheadID = $request['lovheadID'];
            if ($previlage == '2') {
                $create_setup = 1;
            } else {
                $create_setup = 0;
            }
            $sql         = sprintf("SELECT 	recordID,lovheadID,lovValues,description,status from XXBERAR_LOV_TYPE where lovheadID='%s'", mysqli_real_escape_string($this->db, $lovheadID));
            $result      = mysqli_query($this->db, $sql);
            $num_of_rows = mysqli_num_rows($result);
            if ($num_of_rows > 0) {
                while ($row = mysqli_fetch_assoc($result)) {
                    $row      = array_map('utf8_encode', $row);
                    $output[] = $row;
                }
            } else {
                $output = array();
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Lov Line',
                'result' => $output,
                'create_setup' => $create_setup
            );
            $this->response($this->json($out), 200);
        }
    }
    protected function addUserDb($request)
    {
        //$this->Idlecapture($_SESSION['token'],$_SESSION['recordID']);
        $userType         = $request['userType'];
        $userID           = $request['userID'];
        $default_password = $request['password'];
        $password         = md5($request['password']);
        $employeeName     = $request['employerName'];
        $employeeID       = $request['empoyeeID'];
        $subRole          = $request['subRole'];
        $supplierName     = $request['supplierName'];
        $supplierID       = $request['supplierID'];
        $effectiveDate    = $request['effectiveDate'];
        $managerPrivilege = $request['additionalPrivelageManager'];
        $buyerPrivilege   = $request['additionalPrivelageBuyer'];
        $adminPrivilege   = $request['additionalPrivelageAdmin'];
        $flag             = $request['flag'];
        $branches         = $request['branches'];
        $session_prev     = $_SESSION['recordID'];
        $subRoleID        = $_SESSION['subRole'];
        $previlege_find   = "select previlage from (SELECT xua.recordID, xar.subRoleID, xar.privilegeID,(SELECT lovValues
				FROM XXTATA_SP_LOV_TYPE
				WHERE recordID = xar.privilegeID
				)lovValues,xua.managerPrivilege,xua.buyerPrivilege,xua.adminPrivilege, 
				greatest(CASE WHEN(xua.managerPrivilege = 1) THEN xar.managerAccess ELSE 0 END,
						 CASE WHEN(xua.buyerPrivilege = 1) THEN xar.buyerAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 1) THEN xar.adminAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 0 and xua.buyerPrivilege = 0 and xua.managerPrivilege = 0) THEN xar.	noPrivilegeAccess ELSE 0 END) previlage
				From XXTATA_SP_USER_SETUP xua, XXTATA_SP_ACCESS_RIGHTS xar
				Where
					 xar.subRoleID= xua.subRole
				 and xua.recordID='$session_prev')f where f.lovValues='ADMIN' ";
        //echo $previlege_find;
        $result_find      = mysqli_query($this->db, $previlege_find);
        while ($row = mysqli_fetch_array($result_find)) {
            $row       = array_map('utf8_encode', $row);
            $previlage = $row['previlage'];
        }
        if ($previlage == '2') {
            $create_user = 1;
        } else {
            $create_user = 0;
        }
        if ($flag == 1) // creation of lov head
            {
            //print_r($request);
            $sql            = sprintf("insert into XXBERAR_USER_SETUP(userID,password,employeeName,employeeID,subRole,effectiveDate,managerPrivilege,buyerPrivilege,	adminPrivilege,accessType,confirmFlag,createdBY)VALUES ('%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $userID), mysqli_real_escape_string($this->db, $password), mysqli_real_escape_string($this->db, $employeeName), mysqli_real_escape_string($this->db, $employeeID), mysqli_real_escape_string($this->db, $subRole), mysqli_real_escape_string($this->db, $effectiveDate), mysqli_real_escape_string($this->db, $managerPrivilege), mysqli_real_escape_string($this->db, $buyerPrivilege), mysqli_real_escape_string($this->db, $adminPrivilege), mysqli_real_escape_string($this->db, 'User'), mysqli_real_escape_string($this->db, 'Y'), mysqli_real_escape_string($this->db, $session_prev));
            $result         = mysqli_query($this->db, $sql);
            $last_selection = mysqli_insert_id($this->db);
            foreach ($branches as $item) {
                $branchName    = $item['branchName'];
                $defaultBranch = $item['defaultBranch'];
                $effectiveFrom = $item['effectiveFrom'];
                $effectiveTo   = $item['effectiveTo'];
                $sql           = sprintf("insert into XXBERAR_USER_SETUP_LINE(userRecordID, branchName, defaultBranch, effectiveFrom, effectiveTo, createdBY)VALUES ('%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $last_selection), mysqli_real_escape_string($this->db, $branchName), mysqli_real_escape_string($this->db, $defaultBranch), mysqli_real_escape_string($this->db, $effectiveFrom), mysqli_real_escape_string($this->db, $effectiveTo), mysqli_real_escape_string($this->db, $session_prev));
                $result        = mysqli_query($this->db, $sql);
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => "Created Successfully",
                'result' => "[]"
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 2) // edit
            {
            $recordID       = $request['recordID'];
            $changePassword = $request['newPassword'];
            $confirmFlag    = $request['confirmFlag'];
            //$changePassword=md5($request['changePassword']);
            if ($changePassword != '') {
                $changePassword = md5($request['newPassword']);
                $sql            = sprintf("UPDATE XXBERAR_USER_SETUP SET password='$changePassword',managerPrivilege='$managerPrivilege',buyerPrivilege='$buyerPrivilege',adminPrivilege='$adminPrivilege',accessType='User',confirmFlag='$confirmFlag',loginDate='',lastupdateDate=now(),	lastupdateBy='$session_id' WHERE recordID ='$recordID'", mysqli_real_escape_string($this->db, $recordID));
                foreach ($branches as $item) {
                    $branchName    = $item['branchName'];
                    $defaultBranch = $item['defaultBranch'];
                    $effectiveFrom = $item['effectiveFrom'];
                    $effectiveTo   = $item['effectiveTo'];
                    $userRecordID  = $item['userRecordID'];
                    $recordID      = $item['recordID'];
                    if ($recordID > 0) {
                        $sql    = sprintf("UPDATE XXBERAR_USER_SETUP_LINE SET branchName='$branchName',defaultBranch='$defaultBranch',effectiveFrom='$effectiveFrom',effectiveTo='$effectiveTo',lastupdateDate=now(),	lastupdateBy='$session_prev' WHERE recordID ='$recordID'", mysqli_real_escape_string($this->db, $recordID));
                        $result = mysqli_query($this->db, $sql);
                    } else {
                        $sql    = sprintf("insert into XXBERAR_USER_SETUP_LINE(userRecordID, branchName, defaultBranch, effectiveFrom, effectiveTo, createdBY)VALUES ('%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $userRecordID), mysqli_real_escape_string($this->db, $branchName), mysqli_real_escape_string($this->db, $defaultBranch), mysqli_real_escape_string($this->db, $effectiveFrom), mysqli_real_escape_string($this->db, $effectiveTo), mysqli_real_escape_string($this->db, $session_prev));
                        $result = mysqli_query($this->db, $sql);
                    }
                }
            } else {
                 $sql = sprintf("UPDATE XXBERAR_USER_SETUP SET managerPrivilege='$managerPrivilege',buyerPrivilege='$buyerPrivilege',adminPrivilege='$adminPrivilege',accessType='User',confirmFlag='$confirmFlag',lastupdateDate=now(),	lastupdateBy='$session_prev' WHERE recordID ='$recordID'", mysqli_real_escape_string($this->db, $recordID));
                foreach ($branches as $item) {
                    $branchName    = $item['branchName'];
                    $defaultBranch = $item['defaultBranch'];
                    $effectiveFrom = $item['effectiveFrom'];
                    $effectiveTo   = $item['effectiveTo'];
                    $userRecordID  = $item['userRecordID'];
                    $recordID      = $item['recordID'];
                    if ($recordID > 0) {
                        $sql    = sprintf("UPDATE XXBERAR_USER_SETUP_LINE SET branchName='$branchName',defaultBranch='$defaultBranch',effectiveFrom='$effectiveFrom',effectiveTo='$effectiveTo',lastupdateDate=now(),lastupdateBy='$session_prev' WHERE recordID ='$recordID'", mysqli_real_escape_string($this->db, $recordID));
                        $result = mysqli_query($this->db, $sql);
                    } else {
                        $sql122    = sprintf("insert into XXBERAR_USER_SETUP_LINE(userRecordID, branchName, defaultBranch, effectiveFrom, effectiveTo, createdBY)VALUES ('%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $userRecordID), mysqli_real_escape_string($this->db, $branchName), mysqli_real_escape_string($this->db, $defaultBranch), mysqli_real_escape_string($this->db, $effectiveFrom), mysqli_real_escape_string($this->db, $effectiveTo), mysqli_real_escape_string($this->db, $session_prev));
                        $result122 = mysqli_query($this->db, $sql122);
                    }
                }
            }
            $result      = mysqli_query($this->db, $sql);
            $num_of_rows = mysqli_num_rows($result);
            if ($num_of_rows > 0) {
                while ($row = mysqli_fetch_array($result)) {
                    $row      = array_map('utf8_encode', $row);
                    $output[] = $row;
                }
            } else {
                $output = array();
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Updated Successfully',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 3) // list
            {
            $fromDate = $request['fromDate'];
            $toDate   = $request['toDate'];
            $userType = $request['userType'];
            $userName = $request['userName'];
            $subRole  = $request['subRole'];
            // code for pagination start
            $pagenum  = $request['page'];
            $pagesize = 10;
            $offset   = ($pagenum - 1) * $pagesize;
            // code for pagination end
            if ($subRole == '') {
                $subRole_filter = '';
            } else {
                $subRole_filter = " and subRole ='$subRole'";
            }
            if ($userName == '') {
                $userName_filter = '';
            } else {
                $userName_filter = " and recordID ='$userName'";
            }
            if ($fromDate == '' && $toDate == '') {
                $date_filter = '';
            } else {
                $date_filter = "and date(effectiveDate) between '$fromDate' and '$toDate'";
            }
            $sql          = sprintf("SELECT *,(select lovValues from XXBERAR_LOV_TYPE where lovHeadID=2 and recordID=XXBERAR_USER_SETUP.subRole limit 1)subRoleName from XXBERAR_USER_SETUP where 1=1 $date_filter $userType_filter $subRole_filter $userName_filter order by recordID desc LIMIT $offset, $pagesize");
            $sql_count    = sprintf("SELECT count(1) as row_count from XXBERAR_USER_SETUP where 1=1 $date_filter $userType_filter $subRole_filter $userName_filter");
            //echo $sql;
            $result       = mysqli_query($this->db, $sql);
            $result_count = mysqli_query($this->db, $sql_count);
            while ($row = mysqli_fetch_assoc($result_count)) {
                $count_record = $row['row_count'];
            }
            $num_of_rows = mysqli_num_rows($result);
            if ($num_of_rows > 0) {
                while ($row = mysqli_fetch_assoc($result)) {
                    $row      = array_map('utf8_encode', $row);
                    $output[] = $row;
                }
            } else {
                $output = array();
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'User List',
                'result' => $output,
                'create_user' => $create_user,
                'total_count' => $count_record
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 5) {
            $recordID = $request['recordID'];
            $sql      = sprintf("select * from  XXBERAR_USER_SETUP where recordID=$recordID");
            $result   = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $sql12    = sprintf("select * from  XXBERAR_USER_SETUP_LINE where userRecordID=$recordID");
                $result12 = mysqli_query($this->db, $sql12);
                while ($row12 = mysqli_fetch_assoc($result12)) {
                    $row12     = array_map('utf8_encode', $row12);
                    $output1[] = $row12;
                }
                $row             = array_map('utf8_encode', $row);
                $row['branches'] = $output1;
                $output[]        = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => '',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 6) {
            $sql    = sprintf("SELECT distinct	employeeId,employeeName,emailId from  XXBERAR_EMPLOYEES where employeeId not in (select employeeID from XXBERAR_USER_SETUP where employeeID is not null ) order by employeeName asc");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Employee Master',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 7) {
            $employeeId = $request['employeeId'];
            $sql    = sprintf("SELECT branch FROM `XXBERAR_EMPLOYEES` WHERE employeeId ='$employeeId'");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Branch Name',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 8) {
            $sql    = sprintf("SELECT DISTINCT recordID,userID FROM XXBERAR_USER_SETUP");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'userID',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }
    }
    protected function addAccessDB($request)
    {
        //$this->Idlecapture($_SESSION['token'],$_SESSION['recordID']);
        $subRoleID = $request['subRoleID'];
        $flag      = $request['flag'];
        $menuItems = $request['menuItems'];
        $session_id = $_SESSION['recordID'];
        if ($flag == 1) // creation of lov head
            {
            $sql_chk     = sprintf("SELECT 	* from  XXBERAR_ACCESS_RIGHTS where subRoleID='%s'", mysqli_real_escape_string($this->db, $subRoleID));
            //echo $sql_chk;
            $result_chk  = mysqli_query($this->db, $sql_chk);
            $num_of_rows = mysqli_num_rows($result_chk);
            if ($num_of_rows > 0) {
                $sql_chk_del    = sprintf("delete  from  XXBERAR_ACCESS_RIGHTS where subRoleID='%s'", mysqli_real_escape_string($this->db, $subRoleID));
                //echo $sql_chk_del;
                $result_chk_del = mysqli_query($this->db, $sql_chk_del);
            }
            foreach ($menuItems as $item) {
                $recordID          = $item['recordID'];
                $managerAccess     = $item['managerAccess'];     
                $buyerAccess       = $item['buyerAccess'];
                $adminAccess       = $item['adminAccess'];
                $noPrivilegeAccess = $item['noPrivilegeAccess'];

                $sql               = sprintf("insert into XXBERAR_ACCESS_RIGHTS(subRoleID,privilegeID,managerAccess,buyerAccess,adminAccess,	noPrivilegeAccess,createdBY)VALUES ('%s','%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $subRoleID), mysqli_real_escape_string($this->db, $recordID), mysqli_real_escape_string($this->db, $managerAccess), mysqli_real_escape_string($this->db, $buyerAccess), mysqli_real_escape_string($this->db, $adminAccess), mysqli_real_escape_string($this->db, $noPrivilegeAccess), mysqli_real_escape_string($this->db, $session_id));
                //echo 	$sql ;
                $result            = mysqli_query($this->db, $sql);
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => "Updated Successfully",
                'result' => "[]"
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 2) {
            $sql    = sprintf("SELECT 	recordID,lovValues from  XXBERAR_LOV_TYPE where lovHeadID=3 and status =1");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'MENU',
                'result' => $output,
                'create_acess' => $create_acess
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 4) {
            $sql    = sprintf("SELECT 	recordID,lovValues from  XXBERAR_LOV_TYPE where lovHeadID=2 and status =1");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Sub Role',
                'result' => $output,
                'create_acess' => $create_acess
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 3) // list
            {
            if ($subRoleID != '') {
                $sql         = sprintf("SELECT a.recordID, a.lovValues, ifnull(b.managerAccess,0)managerAccess, ifnull(b.buyerAccess,0)buyerAccess, ifnull(b.adminAccess,0)adminAccess ,ifnull(b.noPrivilegeAccess,0)noPrivilegeAccess
        FROM XXBERAR_LOV_TYPE a
        LEFT JOIN XXBERAR_ACCESS_RIGHTS b ON a.recordID = b.privilegeID 
        and  b.subRoleID ='$subRoleID'
        where  a.lovHeadID =3 and a.status =1
        ORDER BY a.lovValues ASC");
                $result      = mysqli_query($this->db, $sql);
                $num_of_rows = mysqli_num_rows($result);
                if ($num_of_rows > 0) {
                    while ($row = mysqli_fetch_assoc($result)) {
                        $row      = array_map('utf8_encode', $row);
                        $output[] = $row;
                    }
                } else {
                    $output = array();
                }
            } else {
                $output = array();
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'User List',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }
    }

    protected function getBranchesAll($request)
    {
        //$this->Idlecapture($_SESSION['token'],$_SESSION['recordID']);
        $branchCode         = $request['branchCode'];
        $branchName         = $request['branchName'];
        $shortDescription   = $request['shortDescription'];
        $costCenter         = $request['costCenter'];
        $branchManager      = $request['branchManager'];
        $branchAddress      = $request['branchAddress'];
        $effectiveStartDate = $request['effectiveStartDate'];
        $effectiveEndDate   = $request['effectiveEndDate'];
        $disable            = $request['disable'];
        $approvalRequired   = $request['approvalRequired'];
        $maxVoucherValue    = $request['maxVoucherValue'];
        $session_id         = $_SESSION['recordID'];
        $sql                = sprintf("SELECT lovValues from  XXBERAR_LOV_TYPE where recordID='$subRoleId'");
        //echo $sql;
        $result             = mysqli_query($this->db, $sql);
        while ($row = mysqli_fetch_array($result)) {
            $row          = array_map('utf8_encode', $row);
            $subRoleValue = $row['lovValues'];
        }
        $session_prev   = $_SESSION['recordID'];
        $subRoleID      = $_SESSION['subRole'];
        $previlege_find = "select previlage from (SELECT xua.recordID, xar.subRoleID, xar.privilegeID,(SELECT lovValues
				FROM XXBERAR_LOV_TYPE
				WHERE recordID = xar.privilegeID
				)lovValues,xua.managerPrivilege,xua.buyerPrivilege,xua.adminPrivilege, 
				greatest(CASE WHEN(xua.managerPrivilege = 1) THEN xar.managerAccess ELSE 0 END,
						 CASE WHEN(xua.buyerPrivilege = 1) THEN xar.buyerAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 1) THEN xar.adminAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 0 and xua.buyerPrivilege = 0 and xua.managerPrivilege = 0) THEN xar.	noPrivilegeAccess ELSE 0 END) previlage
				From XXTATA_SP_USER_SETUP xua, XXTATA_SP_ACCESS_RIGHTS xar
				Where
					 xar.subRoleID= xua.subRole
				 and xua.recordID='$session_prev')f where f.lovValues='ARTIFACTS' ";
        //echo $previlege_find;
        $result_find    = mysqli_query($this->db, $previlege_find);
        while ($row = mysqli_fetch_array($result_find)) {
            $row       = array_map('utf8_encode', $row);
            $previlage = $row['previlage'];
        }
        if ($previlage == '2') {
            $create_branch = 1;
            $save_artifact = 1;
        } else {
            $create_branch = 0;
            $save_artifact = 0;
        }
        $flag = $request['flag'];
        if ($flag == 1) {
            $recordIDbranch = $request['recordID'];
            if ($recordIDbranch == '') {
               $sql            = sprintf("insert into XXBERAR_BRANCHES( branchCode, branchName, shortDescription, costCenter, branchManager, branchAddress, effectiveStartDate, effectiveEndDate, disable, approvalRequired, maxVoucherValue,createdBY)VALUES ('%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $branchCode), mysqli_real_escape_string($this->db, $branchName), mysqli_real_escape_string($this->db, $shortDescription), mysqli_real_escape_string($this->db, $costCenter), mysqli_real_escape_string($this->db, $branchManager), mysqli_real_escape_string($this->db, $branchAddress), mysqli_real_escape_string($this->db, $effectiveStartDate), mysqli_real_escape_string($this->db, $effectiveEndDate), mysqli_real_escape_string($this->db, $disable), mysqli_real_escape_string($this->db, $approvalRequired), mysqli_real_escape_string($this->db, $maxVoucherValue), mysqli_real_escape_string($this->db, $session_id));
                $result         = mysqli_query($this->db, $sql);
                $last_selection = mysqli_insert_id($this->db);
                if ($last_selection == 0) {
                    $out = array(
                        "status_code" => 0,
                        'status' => "failure",
                        'msg' => "Something went wrong",
                        'result' => "[]"
                    );
                    $this->response($this->json($out), 200);
                } else {
                    $out = array(
                        "status_code" => 1,
                        'status' => "Success",
                        'msg' => "Created Successfully",
                        'result' => "[]"
                    );
                    $this->response($this->json($out), 200);
                }
            } else {
               $sql_1    = sprintf("UPDATE XXBERAR_BRANCHES SET branchCode='$branchCode',branchName='$branchName',shortDescription='$shortDescription',costCenter='$costCenter',branchManager='$branchManager',branchAddress='$branchAddress',effectiveStartDate='$effectiveStartDate',effectiveEndDate='$effectiveEndDate',disable='$disable',approvalRequired='$approvalRequired',maxVoucherValue='$maxVoucherValue',lastupdateDate=now(),lastupdateBy='$session_id' WHERE recordID ='$recordIDbranch'", mysqli_real_escape_string($this->db, $recordIDbranch));
                $result_1 = mysqli_query($this->db, $sql_1);
                $out      = array(
                    "status_code" => 1,
                    'status' => "Success",
                    'msg' => "Updated Successfully",
                    'result' => "[]"
                );
                $this->response($this->json($out), 200);
            }
        }
        if ($flag == 2) {
            $recordID = $request['recordID'];
            $sql1     = sprintf("SELECT * from XXBERAR_BRANCHES where recordID='$recordID'");
            $result1  = mysqli_query($this->db, $sql1);
            while ($row = mysqli_fetch_assoc($result1)) {
                $row       = array_map('utf8_encode', $row);
                $output1[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Branches',
                'result' => $output1,
                'save_artifact' => $save_artifact
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 3) {
           // $fromDate   = $request['effectiveStartDate'];
          //  $toDate     = $request['effectiveEndDate'];
            $branchCode = $request['branchCode'];
            $branchName = $request['branchName'];
            // code for pagination start
            $pagenum    = $request['page'];
            $pagesize   = 10;
            $offset     = ($pagenum - 1) * $pagesize;
            // code for pagination end
            if ($branchCode == '') {
                $branchCode_filter = '';
            } else {
                $branchCode_filter = " and branchCode ='$branchCode'";
            }
            if ($branchName == '') {
                $branchName_filter = '';
            } else {
                $branchName_filter = " and branchName ='$branchName'";
            }
           // if ($fromDate == '' && $toDate == '') {
               // $date_filter = '';
           // } else {
              //  $date_filter = "and effectiveStartDate between '$fromDate' and '$toDate'";
          //  }
            $sql1         = sprintf("SELECT * from XXBERAR_BRANCHES where 1=1 $branchCode_filter  $branchName_filter order by recordID desc LIMIT $offset, $pagesize");
            $sql_count    = sprintf("SELECT  count(1) as row_count from XXBERAR_BRANCHES where 1=1 $branchCode_filter  $branchName_filter");
            $result_count = mysqli_query($this->db, $sql_count);
            while ($row = mysqli_fetch_assoc($result_count)) {
                $count_record = $row['row_count'];
            }
            $result1 = mysqli_query($this->db, $sql1);
            while ($row = mysqli_fetch_assoc($result1)) {
                $row       = array_map('utf8_encode', $row);
                $output1[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Branches',
                'result' => $output1,
                'create_branch' => $create_branch,
                'total_count' => $count_record
            );
            $this->response($this->json($out), 200);
        }
		if($flag==4) // Auditor Code
		{
			
		    $sql = sprintf("SELECT branchCode from  XXBERAR_BRANCHES order by recordID desc limit 1");
			
			$result = mysqli_query($this->db, $sql);
			while ($row = mysqli_fetch_array($result)) 
			{
			$row = array_map('utf8_encode', $row);
			$branchCode = $row['branchCode'];
			}
				$num_of_rows = mysqli_num_rows($result);
				if($num_of_rows>0)
				{
					$branchCode=str_replace('BRAN','', $branchCode);
					$branchCode=$branchCode+1;
					$branchCode = sprintf("%04d", $branchCode);
					$branchCode = "BRAN".$branchCode;
					$out = array("status_code" => 0,'status' => "Success", 'msg' => 'Branch Code','result' =>$branchCode);
				}
				else
				{
					$branchCode='BRAN0001';
					$out = array("status_code" => 1,'status' => "Success", 'msg' => 'Branch Code','result' =>$branchCode);
				}
				
					$this->response($this->json($out), 200);		
		}
		   if ($flag == 5) {
            $sql    = sprintf("SELECT distinct branchCode FROM `XXBERAR_BRANCHES` WHERE 1");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'BranchCame',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 6) {
            $sql    = sprintf("SELECT DISTINCT branchName FROM XXBERAR_BRANCHES");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'BranchName',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }
    }
    protected function getJournalsAll($request)
    {
        //$this->Idlecapture($_SESSION['token'],$_SESSION['recordID']);
        $voucherNumber       = $request['voucherNumber'];
        $voucherType         = $request['voucherType'];
        $currency            = $request['currency'];
        $memo                = $request['memo'];
        $manualReceiptNumber = $request['manualReceiptNumber'];
        $voucherDate         = $request['voucherDate'];
        $valueDate           = $request['valueDate'];
        $branch              = $request['branch'];
        $branchManager       = $request['branchManager'];
        $loanId              = $request['loanId'];
        $status              = $request['status'];
        $approvedBy          = $request['approvedBy'];
        $approvedDate        = $request['approvedDate'];
        $voucherAmount       = $request['voucherAmount'];
        $reverse             = $request['reverse'];
        $reverseDate         = $request['reverseDate'];
        $reversalReason      = $request['reversalReason'];
        $relatedSR           = $request['relatedSR'];
        $expenseStart        = $request['expenseStart'];
        $expenseEnd          = $request['expenseEnd'];
        $journalDetails      = $request['journalDetails'];
        $journalAttachments  = $request['journalAttachments'];
        $session_id          = $_SESSION['recordID'];
        $sql                 = sprintf("SELECT lovValues from  XXBERAR_LOV_TYPE where recordID='$subRoleId'");
        //echo $sql;
        $result              = mysqli_query($this->db, $sql);
        while ($row = mysqli_fetch_array($result)) {
            $row          = array_map('utf8_encode', $row);
            $subRoleValue = $row['lovValues'];
        }
        $session_prev   =  $_SESSION['recordID'];
        $subRoleID      = $_SESSION['subRole'];
        $previlege_find = "select previlage from (SELECT xua.recordID, xar.subRoleID, xar.privilegeID,(SELECT lovValues
				FROM XXBERAR_LOV_TYPE
				WHERE recordID = xar.privilegeID
				)lovValues,xua.managerPrivilege,xua.buyerPrivilege,xua.adminPrivilege, 
				greatest(CASE WHEN(xua.managerPrivilege = 1) THEN xar.managerAccess ELSE 0 END,
						 CASE WHEN(xua.buyerPrivilege = 1) THEN xar.buyerAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 1) THEN xar.adminAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 0 and xua.buyerPrivilege = 0 and xua.managerPrivilege = 0) THEN xar.	noPrivilegeAccess ELSE 0 END) previlage
				From XXTATA_SP_USER_SETUP xua, XXTATA_SP_ACCESS_RIGHTS xar
				Where
					 xar.subRoleID= xua.subRole
				 and xua.recordID='$session_prev')f where f.lovValues='ARTIFACTS' ";
        //echo $previlege_find;
        $result_find    = mysqli_query($this->db, $previlege_find);
        while ($row = mysqli_fetch_array($result_find)) {
            $row       = array_map('utf8_encode', $row);
            $previlage = $row['previlage'];
        }
        if ($previlage == '2') {
            $create_branch = 1;
            $save_artifact = 1;
        } else {
            $create_branch = 0;
            $save_artifact = 0;
        }
        $flag = $request['flag'];

        if ($flag == 1) {
            $recordIDjournal = $request['recordID'];
            if ($recordIDjournal == '') {
                $sql            = sprintf("insert into XXBERAR_JOURNALS( voucherNumber, voucherType, currency, memo, manualReceiptNumber, voucherDate, valueDate, branch, branchManager, loanId, status, approvedBy, approvedDate, voucherAmount, reverse, reverseDate, reversalReason, relatedSR, expenseStart, expenseEnd, createdBY)VALUES ('%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $voucherNumber), mysqli_real_escape_string($this->db, $voucherType), mysqli_real_escape_string($this->db, $currency), mysqli_real_escape_string($this->db, $memo), mysqli_real_escape_string($this->db, $manualReceiptNumber), mysqli_real_escape_string($this->db, $voucherDate), mysqli_real_escape_string($this->db, $valueDate), mysqli_real_escape_string($this->db, $branch), mysqli_real_escape_string($this->db, $branchManager), mysqli_real_escape_string($this->db, $loanId), mysqli_real_escape_string($this->db, $status), mysqli_real_escape_string($this->db, $approvedBy), mysqli_real_escape_string($this->db, $approvedDate), mysqli_real_escape_string($this->db, $voucherAmount), mysqli_real_escape_string($this->db, $reverse), mysqli_real_escape_string($this->db, $reverseDate), mysqli_real_escape_string($this->db, $reversalReason), mysqli_real_escape_string($this->db, $relatedSR), mysqli_real_escape_string($this->db, $expenseStart), mysqli_real_escape_string($this->db, $expenseEnd), mysqli_real_escape_string($this->db, $session_id));
				
                $result         = mysqli_query($this->db, $sql);
                $last_selection = mysqli_insert_id($this->db);
				
                foreach ($journalDetails as $item) {
                    $employee           = $item['employee'];
                    $account       	    = $item['account'];
                    $debit              = $item['debit'];
                    $credit 		    = $item['credit'];
                    $lineMemo 		    = $item['lineMemo'];
                    $loanID 		    = $item['loanID'];
                    $employeeType 	    = $item['employeeType'];
                    $journalAttachments = $item['journalAttachments'];
					
					
                    $sql               = sprintf("insert into XXBERAR_JOURNALS_DETAILS(`journalID`, `loanID`,`employeeType`,`employee`, `account`, `debit`, `credit`, `lineMemo`, `createdBY`)VALUES ('%s','%s','%s','%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $last_selection),mysqli_real_escape_string($this->db, $loanID), mysqli_real_escape_string($this->db, $employeeType), mysqli_real_escape_string($this->db, $employee), mysqli_real_escape_string($this->db, $account), mysqli_real_escape_string($this->db, $debit), mysqli_real_escape_string($this->db, $credit), mysqli_real_escape_string($this->db, $lineMemo), mysqli_real_escape_string($this->db, $session_id));
                   // echo 	$sql ;
                    $result            = mysqli_query($this->db, $sql);
                    $lst_insert_id = mysqli_insert_id($this->db);

                    foreach ($journalAttachments as $item) {
                        $type             = $item['type'];
                        $name       	  = $item['name'];
                        $file             = $item['file'];
                        $remarks 		  = $item['remarks'];
    
                        // create code for copy dccshared  to team center
                                             
                        $img1=$file;
                        $folderPath = "JournalsAttachments/";
                        $image_parts = explode(";base64,", $img1);
                        $image_type_aux = explode("image/", $image_parts[0]);
                        $image_type = $image_type_aux[1];
                        if ($image_type == '') {
                                $image_type_aux = explode("application/", $image_parts[0]);
                                $image_type = $image_type_aux[1];
                            }
                        $image_base64 = base64_decode($image_parts[1]);
                        $file = $folderPath.$name;
                        
                         file_put_contents($file, $image_base64);
                       
                        // chmod($file, 0777);
                        // $type = $image_type;
                        // $image_path = "/var/www/html/SFA/public_html/berarFinance/Transaction/";
                        // $image_path .= $file;
    
                        $sql    = sprintf("insert into XXBERAR_JOURNALS_ATTACHMENTS(`journalID`, `type`, `name`, `file`, `remarks`, `createdBY`)VALUES ('%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $lst_insert_id), mysqli_real_escape_string($this->db, $type), mysqli_real_escape_string($this->db, $name), mysqli_real_escape_string($this->db, $file), mysqli_real_escape_string($this->db, $remarks), mysqli_real_escape_string($this->db, $session_id));
                       // echo 	$sql ;
                        $result            = mysqli_query($this->db, $sql);
                    }
                }

                
				
                if ($last_selection == 0) {
                    $out = array(
                        "status_code" => 0,
                        'status' => "failure",
                        'msg' => "Something went wrong",
                        'result' => "[]"
                    );
                    $this->response($this->json($out), 200);
                } else {
                    $out = array(
                        "status_code" => 1,
                        'status' => "Success",
                        'msg' => "Created Successfully",
                        'result' => "[]"
                    );
                    $this->response($this->json($out), 200);
                }
            } else {
                 $sql_1    = sprintf("UPDATE XXBERAR_JOURNALS SET voucherNumber='$voucherNumber',voucherType='$voucherType',currency='$currency',memo='$memo',manualReceiptNumber='$manualReceiptNumber',voucherDate='$voucherDate',valueDate='$valueDate',branch='$branch',branchManager='$branchManager',loanId='$loanId',status='$status',approvedBy='$approvedBy',approvedDate='$approvedDate',voucherAmount='$voucherAmount',`reverse`='$reverse',reverseDate='$reverseDate',reversalReason='$reversalReason',relatedSR='$relatedSR',expenseStart='$expenseStart',expenseEnd='$expenseEnd',lastupdateDate=now(),lastupdateBy='$session_id' WHERE recordID ='$recordIDjournal'", mysqli_real_escape_string($this->db, $recordIDjournal));

                foreach ($journalDetails as $item) {
                    $employee          = $item['employee'];
                    $account       	   = $item['account'];
                    $debit             = $item['debit'];
                    $credit 		   = $item['credit'];
                    $lineMemo 		   = $item['lineMemo'];
                    $recordID 		  = $item['recordID'];
                    $loanID 		  = $item['loanID'];
                    $employeeType 		  = $item['employeeType'];
                    $journalAttachments = $item['journalAttachments'];

                    if($recordID>0){
                        
                    $sql               = sprintf("UPDATE XXBERAR_JOURNALS_DETAILS SET employee='$employee',`employeeType`='$employeeType',loanID='$loanID',account='$account',debit='$debit',credit='$credit',lineMemo='$lineMemo',lastupdateDate=now(),lastupdateBy='$session_id' WHERE recordID ='$recordID'", mysqli_real_escape_string($this->db, $recordID));
                    // echo 	$sql ;
                     $result            = mysqli_query($this->db, $sql);
                    }else{
                        $sql               = sprintf("insert into XXBERAR_JOURNALS_DETAILS(`journalID`, `employeeType`,`employee`,`loanID`, `account`, `debit`, `credit`, `lineMemo`, `createdBY`)VALUES ('%s','%s','%s','%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $recordIDjournal),  mysqli_real_escape_string($this->db, $loanID),mysqli_real_escape_string($this->db, $employeeType),mysqli_real_escape_string($this->db, $employee), mysqli_real_escape_string($this->db, $account), mysqli_real_escape_string($this->db, $debit), mysqli_real_escape_string($this->db, $credit), mysqli_real_escape_string($this->db, $lineMemo), mysqli_real_escape_string($this->db, $session_id));
                        // echo 	$sql ;
                         $result            = mysqli_query($this->db, $sql);        
                    }

                    foreach ($journalAttachments as $item) {
                        $type             = $item['type'];
                        $name       	  = $item['name'];
                        $file             = $item['file'];
                        $remarks 		  = $item['remarks'];
                        $recordID1 		  = $item['recordID'];
                        $journalID 		  = $item['journalID'];
    
                      if($recordID1> 0){
                        // create code for copy dccshared  to team center
                        $sql               = sprintf("UPDATE XXBERAR_JOURNALS_ATTACHMENTS SET remarks='$remarks',lastupdateDate=now(),lastupdateBy='$session_id' WHERE recordID ='$recordID1'", mysqli_real_escape_string($this->db, $recordID1));
                        // echo 	$sql ;
                        $result            = mysqli_query($this->db, $sql);                
                      
                      }else{
    
                        $img1=$file;
                        $folderPath = "JournalsAttachments/";
                        $image_parts = explode(";base64,", $img1);
                        $image_type_aux = explode("image/", $image_parts[0]);
                        $image_type = $image_type_aux[1];
                        if ($image_type == '') {
                                $image_type_aux = explode("application/", $image_parts[0]);
                                $image_type = $image_type_aux[1];
                            }
                        $image_base64 = base64_decode($image_parts[1]);
                        $file = $folderPath.$name;
                        
                         file_put_contents($file, $image_base64);
                       
                       $sql    = sprintf("insert into XXBERAR_JOURNALS_ATTACHMENTS(`journalID`, `type`, `name`, `file`, `remarks`, `createdBY`)VALUES ('%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $recordID), mysqli_real_escape_string($this->db, $type), mysqli_real_escape_string($this->db, $name), mysqli_real_escape_string($this->db, $file), mysqli_real_escape_string($this->db, $remarks), mysqli_real_escape_string($this->db, $session_id));
                       // echo 	$sql ;
                        $result   = mysqli_query($this->db, $sql);
                      
    
                      }
                    }
                    
                }

                $result_1 = mysqli_query($this->db, $sql_1);
                $out      = array(
                    "status_code" => 1,
                    'status' => "Success",
                    'msg' => "Updated Successfully",
                    'result' => "[]"
                );
                $this->response($this->json($out), 200);
            }
        }
		
        if ($flag == 2) {
            $recordID = $request['recordID'];
            $sql1     = sprintf("SELECT *,(SELECT employeeName FROM XXBERAR_USER_SETUP WHERE recordID = XXBERAR_JOURNALS.createdBY)created from XXBERAR_JOURNALS where recordID='$recordID'");
            $result1  = mysqli_query($this->db, $sql1);

            while ($row = mysqli_fetch_assoc($result1)) {
                 $sql12    = sprintf("select a.*,b.DISPLAY as Number,if(a.type='customer',d.customer_name,c.VENDOR_NAME) as VENDOR_NAME,e.LOAN_ACCOUNT_NUMBER from  XXBERAR_JOURNALS_DETAILS a left join XXBERAR_CHARTOFACCOUNT b on b.ACCOUNT_NUMBER_ID = a.account left join XXBERAR_VENDOR_MASTER c on c.INTERNALID = a.employee left join XXBERAR_COMMISSION_LINE d on d.customer_id = a.employee and a.type='customer' left join XXBERAR_LOAN_MASTER e on e.LOAN_ACCOUNT_ID = a.loanID where a.journalID=$recordID");
                $result12 = mysqli_query($this->db, $sql12);
               
                while ($row12 = mysqli_fetch_assoc($result12)) {
                    $recordID_attach = $row12['recordID'];
                    $sql13    = "select * from  XXBERAR_JOURNALS_ATTACHMENTS where journalID=$recordID_attach";
                    $result13 = mysqli_query($this->db, $sql13);
                    $rout = array();
                    while ($row13 = mysqli_fetch_assoc($result13)) {
                        $row13     = array_map('utf8_encode', $row13);
                        $rout[] = $row13;
                    }

                    $row12     = array_map('utf8_encode', $row12);
                    $row12['journalAttachments'] = $rout;
                    $output2[] = $row12;
                   
                }  
                $row  = array_map('utf8_encode', $row);
                $row['journalDetails'] = $output2;
                $output1[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Journals',
                'result' => $output1,
                'save_artifact' => $save_artifact
            );
            $this->response($this->json($out), 200);
        }

        if ($flag == 3) {

            $fromDate   = $request['effectiveStartDate'];
            $toDate     = $request['effectiveEndDate'];
            $branch = $request['branch'];
            $voucherType = $request['voucherType'];
            $voucherNumber = $request['voucherNumber'];
            $status = $request['status'];
            $role = $request['role'];
            // code for pagination start
            $pagenum    = $request['page'];
            $pagesize   = 10;
            $offset     = ($pagenum - 1) * $pagesize;
            // code for pagination end
            if ($branch == '') {
                $branch_filter = '';
            } else {
                $branch_filter = " and branch ='$branch'";
            }
            if ($voucherType == '') {
                $voucherType_filter = '';
            } else {
                $voucherType_filter = " and voucherType ='$voucherType'";
            }
			if ($voucherNumber == '') {
                $voucherNumber_filter = '';
            } else {
                $voucherNumber_filter = " and voucherNumber ='$voucherNumber'";
            }
			if ($status == '') {
                $status_filter = '';
            } else {
                $status_filter = " and status ='$status'";
            }
            if ($fromDate == '' && $toDate == '') {
                $date_filter = '';
            } else {
                $date_filter = "and voucherDate between '$fromDate' and '$toDate'";
            }
            if($role == 'Cashier'){
                $role_filter = "and voucherType !='Commission_Payment'";
            }else{
                $role_filter = '';
            }

            $sql1         = sprintf("SELECT * from XXBERAR_JOURNALS where 1=1 $branch_filter $date_filter $voucherType_filter $voucherNumber_filter $status_filter $role_filter  order by recordID desc LIMIT $offset, $pagesize");
            $sql_count    = sprintf("SELECT  count(1) as row_count from XXBERAR_JOURNALS where 1=1 $branch_filter $date_filter $voucherType_filter $voucherNumber_filter $status_filter $role_filter");
            $result_count = mysqli_query($this->db, $sql_count);
            while ($row = mysqli_fetch_assoc($result_count)) {
                $count_record = $row['row_count'];
            }
            $result1 = mysqli_query($this->db, $sql1);
            while ($row = mysqli_fetch_assoc($result1)) {
                $row       = array_map('utf8_encode', $row);
                $output1[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Journals',
                'result' => $output1,
                'create_journal' => $create_journal,
                'total_count' => $count_record
            );
            $this->response($this->json($out), 200);
        }
        if($flag==4) // Voucher Code
		{
			
		    $sql = sprintf("SELECT voucherNumber from  XXBERAR_JOURNALS order by recordID desc limit 1");
			
			$result = mysqli_query($this->db, $sql);
			while ($row = mysqli_fetch_array($result)) 
			{
			$row = array_map('utf8_encode', $row);
			$voucherNumber = $row['voucherNumber'];
			}
				$num_of_rows = mysqli_num_rows($result);
				if($num_of_rows>0)
				{
					$voucherNumber=str_replace('Jour','', $voucherNumber);
					$voucherNumber=$voucherNumber+1;
					$voucherNumber = sprintf("%04d", $voucherNumber);
					$voucherNumber = "Jour".$voucherNumber;
					$out = array("status_code" => 0,'status' => "Success", 'msg' => 'Voucher Code','result' =>$voucherNumber);
				}
				else
				{
					$voucherNumber='Jour0001';
					$out = array("status_code" => 1,'status' => "Success", 'msg' => 'Voucher Code','result' =>$voucherNumber);
				}
				
					$this->response($this->json($out), 200);		
		}
        if ($flag == 5) { //branch Lov summary
            $sql    = sprintf("SELECT DISTINCT branch FROM XXBERAR_JOURNALS");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'branch',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }

        if ($flag == 6) { //voucherType Lov summary
            $sql    = sprintf("SELECT DISTINCT voucherType FROM XXBERAR_JOURNALS");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'voucherType',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }

        if ($flag == 7) { //voucherType Lov summary
            $branch = $request['branch'];
            $role = $request['role'];
            if($branch == ''){
                $branch_filter ='';
            }else{
                $branch_filter = "and branch ='$branch'";
            }
            if($role == 'Cashier'){
                 $sql    = sprintf("SELECT DISTINCT voucherNumber FROM XXBERAR_JOURNALS where 1=1 and voucherType !='Commission_Payment' $branch_filter");
            }else{
                 $sql    = sprintf("SELECT DISTINCT voucherNumber FROM XXBERAR_JOURNALS where 1=1 $branch_filter");
            }
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'voucherType',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }

        if ($flag == 8) {
            $sql    = sprintf("SELECT recordID,lovValues from  XXBERAR_LOV_TYPE where lovHeadID=1 and status =1");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Status',
                'result' => $output,
                'create_acess' => $create_acess
            );
            $this->response($this->json($out), 200);
        }

        if ($flag == 9) {
            $employeeType = $request['employeeType'];

            if($employeeType == 'Employee'){
                $sql    = sprintf("SELECT employeeId as INTERNALID,employeeName as VENDOR_NAME from  XXBERAR_EMPLOYEES");
            }else{
                $sql    = sprintf("SELECT INTERNALID,VENDOR_NAME from  XXBERAR_VENDOR_MASTER where CATEGORY ='$employeeType'");
            }

            
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'VoucherEmployee',
                'result' => $output,
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 10) {
            $sql    = sprintf("SELECT DISTINCT CASH_BANK as TYPE from  XXBERAR_CHARTOFACCOUNT where CASH_BANK !='' order by CASH_BANK asc");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Type',
                'result' => $output,
            );
            $this->response($this->json($out), 200);
        }

        if ($flag == 11) {
            $TYPE = $request['TYPE'];
            $sql    = sprintf("SELECT ACCOUNT_NUMBER_ID,NUMBER from  XXBERAR_CHARTOFACCOUNT where CASH_BANK = '$TYPE'");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Type',
                'result' => $output,
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 12) {
            $sql    = sprintf("SELECT 	recordID,lovValues from  XXBERAR_LOV_TYPE where lovHeadID=4 and status =1");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'VoucherType',
                'result' => $output,
                'create_acess' => $create_acess
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 13) {
            
            $branch = $request['branch'];
            $search = $request['search'];
            if($branch == ''){
                $branch_filter ='';
            }else{
                $branch_filter = "and BRANCH_NAME ='$branch'";
            }


            $pagenum    = $request['page'];
            $pagesize   = 10;
            $offset     = ($pagenum - 1) * $pagesize;

            if($search){
                 $sql    = "SELECT distinct LOAN_ACCOUNT_ID,LOAN_ACCOUNT_NUMBER from  XXBERAR_LOAN_MASTER where  LOAN_ACCOUNT_NUMBER LIKE '%$search%' $branch_filter  LIMIT $offset, $pagesize";
            }else{
               
                $sql    = "SELECT distinct LOAN_ACCOUNT_ID,LOAN_ACCOUNT_NUMBER from  XXBERAR_LOAN_MASTER where LOAN_ACCOUNT_NUMBER !='' $branch_filter  LIMIT $offset, $pagesize";

            }

            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'VoucherType',
                'result' => $output,
                'create_acess' => $create_acess
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 14) {
            $branch = $request['branch'];
            $type = $request['TYPE']; 
            if($type == 'Petty Cash'){
                  $sql    = sprintf("SELECT a.account,b.DISPLAY as Number from XXBERAR_ACCOUNT_SETUP a left join XXBERAR_CHARTOFACCOUNT b on b.ACCOUNT_NUMBER_ID = a.account where a.branch='$branch' and a.type in( 'Cash','Expense')");
            }elseif($type == 'Cash Receipt'){
                  $sql    = sprintf("SELECT a.account,b.DISPLAY as Number from XXBERAR_ACCOUNT_SETUP a left join XXBERAR_CHARTOFACCOUNT b on b.ACCOUNT_NUMBER_ID = a.account where a.branch='$branch' and a.type in ('Cash','Receivables')");
            }else{
                if($type == 'Bank Deposit'){
                    $sql    = sprintf("SELECT a.account,b.DISPLAY as Number from XXBERAR_ACCOUNT_SETUP a left join XXBERAR_CHARTOFACCOUNT b on b.ACCOUNT_NUMBER_ID = a.account where a.branch='$branch' and a.type in ('Cash','Bank')");
                }

            }
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'account',
                'result' => $output,
                'create_acess' => $create_acess
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 15) {
            $branch = $request['branch'];
            $sql    = sprintf("SELECT  branchManager from  XXBERAR_BRANCHES where branchName = '$branch'");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'branchManager',
                'result' => $output,
                'create_acess' => $create_acess
            );
            $this->response($this->json($out), 200);
        }

        if ($flag == 16) {
            $account = $request['account'];
            $branch = $request['branch'];
            $sql    = sprintf("SELECT type from  XXBERAR_ACCOUNT_SETUP where branch = '$branch' and account ='$account'");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'type',
                'result' => $output,
                'create_acess' => $create_acess
            );
            $this->response($this->json($out), 200);
        }


        if($flag == 17){ // approval api     
            
            $recordIDjournal = $request['recordID'];
            $Rejection_Reason = $request['Rejection_Reason'];
            $Rejection_Date = $request['Rejection_Date'];

            $sql_1    = sprintf("UPDATE XXBERAR_JOURNALS SET voucherNumber='$voucherNumber',voucherType='$voucherType',currency='$currency',memo='$memo',manualReceiptNumber='$manualReceiptNumber',voucherDate='$voucherDate',valueDate='$valueDate',branch='$branch',branchManager='$branchManager',loanId=' $loanId',status='$status',approvedBy='$approvedBy',approvedDate='$approvedDate',Rejection_Reason='$Rejection_Reason',Rejection_Date='$Rejection_Date',voucherAmount='$voucherAmount',reverse='$reverse',reverseDate='$reverseDate',reversalReason='$reversalReason',relatedSR='$relatedSR',expenseStart='$expenseStart',expenseEnd='$expenseEnd',lastupdateDate=now(),lastupdateBy='$session_id' WHERE recordID ='$recordIDjournal'", mysqli_real_escape_string($this->db, $recordIDjournal));

            foreach ($journalDetails as $item) {
                $employee          = $item['employee'];
                $account       	   = $item['account'];
                $debit             = $item['debit'];
                $credit 		   = $item['credit'];
                $lineMemo 		   = $item['lineMemo'];
                $recordID 		   = $item['recordID'];
                $loanID 		   = $item['loanID'];

                if($recordID>0){
                    
                $sql               = sprintf("UPDATE XXBERAR_JOURNALS_DETAILS SET employee='$employee',loanID='$loanID',account='$account',debit='$debit',credit='$credit',lineMemo='$lineMemo',lastupdateDate=now(),lastupdateBy='$session_id' WHERE recordID ='$recordID'", mysqli_real_escape_string($this->db, $recordID));
                // echo 	$sql ;
                 $result            = mysqli_query($this->db, $sql);
                }else{
                    $sql               = sprintf("insert into XXBERAR_JOURNALS_DETAILS(`journalID`, `employee`,`loanID`, `account`, `debit`, `credit`, `lineMemo`, `createdBY`)VALUES ('%s','%s','%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $recordIDjournal),  mysqli_real_escape_string($this->db, $loanID),mysqli_real_escape_string($this->db, $employee), mysqli_real_escape_string($this->db, $account), mysqli_real_escape_string($this->db, $debit), mysqli_real_escape_string($this->db, $credit), mysqli_real_escape_string($this->db, $lineMemo), mysqli_real_escape_string($this->db, $session_id));
                    // echo 	$sql ;
                     $result            = mysqli_query($this->db, $sql);        
                }
                

            }

            foreach ($journalAttachments as $item) {
                $type             = $item['type'];
                $name       	  = $item['name'];
                $file             = $item['file'];
                $remarks 		  = $item['remarks'];
                $recordID1 		  = $item['recordID'];
                $journalID 		  = $item['journalID'];

              if($recordID1> 0){
                // create code for copy dccshared  to team center
                $sql               = sprintf("UPDATE XXBERAR_JOURNALS_ATTACHMENTS SET remarks='$remarks',lastupdateDate=now(),lastupdateBy='$session_id' WHERE recordID ='$recordID1'", mysqli_real_escape_string($this->db, $recordID1));
                // echo 	$sql ;
                $result            = mysqli_query($this->db, $sql);                
              
              }else{

                $img1=$file;
                $folderPath = "JournalsAttachments/";
                $image_parts = explode(";base64,", $img1);
                $image_type_aux = explode("image/", $image_parts[0]);
                $image_type = $image_type_aux[1];
                if ($image_type == '') {
                        $image_type_aux = explode("application/", $image_parts[0]);
                        $image_type = $image_type_aux[1];
                    }
                $image_base64 = base64_decode($image_parts[1]);
                $file = $folderPath.$name;
                
                 file_put_contents($file, $image_base64);
               
               $sql    = sprintf("insert into XXBERAR_JOURNALS_ATTACHMENTS(`journalID`, `type`, `name`, `file`, `remarks`, `createdBY`)VALUES ('%s','%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $recordIDjournal), mysqli_real_escape_string($this->db, $type), mysqli_real_escape_string($this->db, $name), mysqli_real_escape_string($this->db, $file), mysqli_real_escape_string($this->db, $remarks), mysqli_real_escape_string($this->db, $session_id));
               // echo 	$sql ;
                $result  = mysqli_query($this->db, $sql);

              }
            }

            $result_1 = mysqli_query($this->db, $sql_1);
            $out      = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => "Updated Successfully",
                'result' => "[]"
            );
            $this->response($this->json($out), 200);

        }

        if($flag == 18){ // bulk appprove
            $result = $request['result'];

            foreach($result as $itemm){
                $voucherNumber = $itemm['voucherNumber'];
                $recordID = $itemm['recordID'];
                $approvedBy = $itemm['approvedBy'];
                $approvedDate = $itemm['approvedDate'];
                $Rejection_Reason = $itemm['Rejection_Reason'];
                $Rejection_Date = $itemm['Rejection_Date'];
                $Approve_Reject = $itemm['Approve_Reject'];

                 $sql_1    = sprintf("UPDATE XXBERAR_JOURNALS SET status='$Approve_Reject',approvedBy='$approvedBy',approvedDate='$approvedDate',Rejection_Reason='$Rejection_Reason',Rejection_Date='$Rejection_Date',lastupdateDate=now(),lastupdateBy='$session_id' WHERE recordID ='$recordID'", mysqli_real_escape_string($this->db, $recordID));
                    $result_1 = mysqli_query($this->db, $sql_1);
                   
            } 
                $out      = array(
                    "status_code" => 1,
                    'status' => "Success",
                    'msg' => "Approved Successfully",
                    'result' => "[]"
                );
                $this->response($this->json($out), 200); 
        }

        if ($flag == 19) {
            $sql    = sprintf("SELECT 	recordID,lovValues from  XXBERAR_LOV_TYPE where lovHeadID=7 and status =1");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'employeeType',
                'result' => $output,
            );
            $this->response($this->json($out), 200);
        }

    }


    protected function getaccountSetup($request)
    {
        //$this->Idlecapture($_SESSION['token'],$_SESSION['recordID']);
        
        $accountsetup   = $request['result'];
       
        $session_id         = $_SESSION['recordID'];
        $sql                = sprintf("SELECT lovValues from  XXBERAR_LOV_TYPE where recordID='$subRoleId'");
        //echo $sql;
        $result             = mysqli_query($this->db, $sql);
        while ($row = mysqli_fetch_array($result)) {
            $row          = array_map('utf8_encode', $row);
            $subRoleValue = $row['lovValues'];
        }
        $session_prev   = $_SESSION['recordID'];
        $subRoleID      = $_SESSION['subRole'];
        $previlege_find = "select previlage from (SELECT xua.recordID, xar.subRoleID, xar.privilegeID,(SELECT lovValues
				FROM XXBERAR_LOV_TYPE
				WHERE recordID = xar.privilegeID
				)lovValues,xua.managerPrivilege,xua.buyerPrivilege,xua.adminPrivilege, 
				greatest(CASE WHEN(xua.managerPrivilege = 1) THEN xar.managerAccess ELSE 0 END,
						 CASE WHEN(xua.buyerPrivilege = 1) THEN xar.buyerAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 1) THEN xar.adminAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 0 and xua.buyerPrivilege = 0 and xua.managerPrivilege = 0) THEN xar.	noPrivilegeAccess ELSE 0 END) previlage
				From XXTATA_SP_USER_SETUP xua, XXTATA_SP_ACCESS_RIGHTS xar
				Where
					 xar.subRoleID= xua.subRole
				 and xua.recordID='$session_prev')f where f.lovValues='ARTIFACTS' ";
        //echo $previlege_find;
        $result_find    = mysqli_query($this->db, $previlege_find);
        while ($row = mysqli_fetch_array($result_find)) {
            $row       = array_map('utf8_encode', $row);
            $previlage = $row['previlage'];
        }
        if ($previlage == '2') {
            $create_branch = 1;
            $save_artifact = 1;
        } else {
            $create_branch = 0;
            $save_artifact = 0;
        }
        $flag = $request['flag'];

        if ($flag == 1) {
            
            
            foreach($accountsetup as $item){
                $branch          = $item['branch'];
                $type            = $item['type'];
                $account         = $item['account'];
                $effectiveFrom   = $item['effectiveFrom'];
                $recordIDaccount = $item['recordID'];

                if ($recordIDaccount == '') {
                    $sql            = sprintf("insert into XXBERAR_ACCOUNT_SETUP( branch, type, account, effectiveFrom,createdBY)VALUES ('%s','%s','%s','%s','%s')", mysqli_real_escape_string($this->db, $branch), mysqli_real_escape_string($this->db, $type), mysqli_real_escape_string($this->db, $account), mysqli_real_escape_string($this->db, $effectiveFrom), mysqli_real_escape_string($this->db, $session_id));
                    $result         = mysqli_query($this->db, $sql);
                    $last_selection = mysqli_insert_id($this->db);
                    if ($last_selection == 0) {
                        $out = array(
                            "status_code" => 0,
                            'status' => "failure",
                            'msg' => "Something went wrong",
                            'result' => "[]"
                        );
                        
                    } else {
                        $out = array(
                            "status_code" => 1,
                            'status' => "Success",
                            'msg' => "Created Successfully",
                            'result' => "[]"
                        );
                    }
                } else {
                 $sql_1    = sprintf("UPDATE XXBERAR_ACCOUNT_SETUP SET branch='$branch',type='$type',account='$account',effectiveFrom='$effectiveFrom',lastupdateDate=now(),lastupdateBy='$session_id' WHERE recordID ='$recordIDaccount'", mysqli_real_escape_string($this->db, $recordIDaccount));
                    $result_1 = mysqli_query($this->db, $sql_1);
                    $out      = array(
                        "status_code" => 1,
                        'status' => "Success",
                        'msg' => "Updated Successfully",
                        'result' => "[]"
                    );
                    
                }
            }
            $this->response($this->json($out), 200);
        }
        if ($flag == 2) {
            $recordID = $request['recordID'];
            $sql1     = sprintf("SELECT * from XXBERAR_ACCOUNT_SETUP where recordID='$recordID'");
            $result1  = mysqli_query($this->db, $sql1);
            while ($row = mysqli_fetch_assoc($result1)) {
                $row       = array_map('utf8_encode', $row);
                $output1[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'accountSetup',
                'result' => $output1,
                'save_artifact' => $save_artifact
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 3) {
            $fromDate   = $request['effectiveStartDate'];
            $toDate     = $request['effectiveEndDate'];
            $branch = $request['branch'];
            $type = $request['type'];
            // code for pagination start
            $pagenum    = $request['page'];
            $pagesize   = 10;
            $offset     = ($pagenum - 1) * $pagesize;
            // code for pagination end
            if ($branch == '') {
                $branch_filter = '';
            } else {
                $branch_filter = " and a.branch ='$branch'";
            }
            if ($type == '') {
                $type_filter = '';
            } else {
                $type_filter = " and a.type ='$type'";
            }
            if ($fromDate == '' && $toDate == '') {
                $date_filter = '';
            } else {
                $date_filter = "and a.effectiveFrom between '$fromDate' and '$toDate'";
            }
            $sql1         = sprintf("SELECT a.*,b.NUMBER from XXBERAR_ACCOUNT_SETUP a left join XXBERAR_CHARTOFACCOUNT b on b.ACCOUNT_NUMBER_ID = a.account where 1=1 $branch_filter $date_filter $type_filter order by recordID desc LIMIT $offset, $pagesize");
            $sql_count    = sprintf("SELECT  count(1) as row_count from XXBERAR_ACCOUNT_SETUP a left join XXBERAR_CHARTOFACCOUNT b on b.ACCOUNT_NUMBER_ID = a.account where 1=1 $branch_filter $date_filter $type_filter");
            $result_count = mysqli_query($this->db, $sql_count);
            while ($row = mysqli_fetch_assoc($result_count)) {
                $count_record = $row['row_count'];
            }
            $result1 = mysqli_query($this->db, $sql1);
            while ($row = mysqli_fetch_assoc($result1)) {
                $row       = array_map('utf8_encode', $row);
                $output1[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Branches',
                'result' => $output1,
                'create_branch' => $create_branch,
                'total_count' => $count_record
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 4) { //branch Lov summary
            $sql    = sprintf("SELECT DISTINCT branch FROM XXBERAR_ACCOUNT_SETUP");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'branch',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 5) { //branch Lov summary
            $sql    = sprintf("SELECT DISTINCT type FROM XXBERAR_ACCOUNT_SETUP");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'branch',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }

        if ($flag == 6) { //branch Lov summary
            $sql    = sprintf("SELECT DISTINCT branchCode,branchName FROM XXBERAR_BRANCHES");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'branch',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }
		
    }


    protected function getcommission($request)
    {
        //$this->Idlecapture($_SESSION['token'],$_SESSION['recordID']);
        
        $accountsetup   = $request['result'];
       
        $session_id         = $_SESSION['recordID'];
        $sql                = sprintf("SELECT lovValues from  XXBERAR_LOV_TYPE where recordID='$subRoleId'");
        //echo $sql;
        $result             = mysqli_query($this->db, $sql);
        while ($row = mysqli_fetch_array($result)) {
            $row          = array_map('utf8_encode', $row);
            $subRoleValue = $row['lovValues'];
        }
        $session_prev   = $_SESSION['recordID'];
        $subRoleID      = $_SESSION['subRole'];
        $previlege_find = "select previlage from (SELECT xua.recordID, xar.subRoleID, xar.privilegeID,(SELECT lovValues
				FROM XXBERAR_LOV_TYPE
				WHERE recordID = xar.privilegeID
				)lovValues,xua.managerPrivilege,xua.buyerPrivilege,xua.adminPrivilege, 
				greatest(CASE WHEN(xua.managerPrivilege = 1) THEN xar.managerAccess ELSE 0 END,
						 CASE WHEN(xua.buyerPrivilege = 1) THEN xar.buyerAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 1) THEN xar.adminAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 0 and xua.buyerPrivilege = 0 and xua.managerPrivilege = 0) THEN xar.	noPrivilegeAccess ELSE 0 END) previlage
				From XXTATA_SP_USER_SETUP xua, XXTATA_SP_ACCESS_RIGHTS xar
				Where
					 xar.subRoleID= xua.subRole
				 and xua.recordID='$session_prev')f where f.lovValues='ARTIFACTS' ";
        //echo $previlege_find;
        $result_find    = mysqli_query($this->db, $previlege_find);
        while ($row = mysqli_fetch_array($result_find)) {
            $row       = array_map('utf8_encode', $row);
            $previlage = $row['previlage'];
        }
        if ($previlage == '2') {
            $create_branch = 1;
            $save_artifact = 1;
        } else {
            $create_branch = 0;
            $save_artifact = 0;
        }
        $flag = $request['flag'];

        if ($flag == 1) {
            $Commission_Header_ID = $request['Commission_Header_ID'];
            $Authorized_By = $request['Authorized_By'];
            $Authorization_Date = $request['Authorization_Date'];
            $memo = $request['memo'];
            $comissionLine = $request['comissionLine'];

                 $sql_1    = sprintf("UPDATE XXBERAR_COMMISSION_HEADER SET Status='Approved',Authorized_By='$Authorized_By',Authorization_Date='$Authorization_Date',memo='$memo',lastupdateDate=now(),lastupdateBy='$session_id' WHERE Commission_Header_ID ='$Commission_Header_ID'", mysqli_real_escape_string($this->db, $Commission_Header_ID));
                 $result_34 = mysqli_query($this->db, $sql_1);

                 foreach($comissionLine as $itemm){
                     $Comm_Line_ID = $itemm['Comm_Line_ID'];
                     $sub_dealer = $itemm['sub_dealer'];
     
                      $sql_2    = sprintf("UPDATE XXBERAR_COMMISSION_LINE SET sub_dealer='$sub_dealer',lastupdateDate=now(),lastupdateBy='$session_id' WHERE Comm_Line_ID ='$Comm_Line_ID'", mysqli_real_escape_string($this->db, $Comm_Line_ID));
                     $result2 = mysqli_query($this->db, $sql_2);
                        
                 }
                    
                    $out      = array(
                        "status_code" => 1,
                        'status' => "Success",
                        'msg' => "Approved Successfully",
                        'result' => "[]"
                    );
                    $this->response($this->json($out), 200);  
           
        }
        if ($flag == 2) {
            $recordID = $request['recordID'];
            $sql1     = sprintf("SELECT * from XXBERAR_COMMISSION_HEADER where Commission_Header_ID='$recordID'");
            $result1  = mysqli_query($this->db, $sql1);
            while ($row = mysqli_fetch_assoc($result1)) {
                $sql12    = sprintf("select *,(select Product_type_Name from XXBERAR_SALES_DIFINITION where Product_Type = XXBERAR_COMMISSION_LINE.Product_Type limit 1) as Product_Name from  XXBERAR_COMMISSION_LINE where Commission_Header_ID='$recordID'");
                $result12 = mysqli_query($this->db, $sql12);
                while ($row12 = mysqli_fetch_assoc($result12)) {
                    $row12     = array_map('utf8_encode', $row12);
                    $output2[] = $row12;
                }

                $row       = array_map('utf8_encode', $row);
                $row['comissionLine'] = $output2;
                $output1[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'commission',
                'result' => $output1,
                'save_artifact' => $save_artifact
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 3) {
            $Comission_Period   = $request['Comission_Period'];
            $branch = $request['branch'];
            $beneficiary = $request['beneficiary'];
            $type = $request['type'];
            $status = $request['status'];
            // code for pagination start
            $pagenum    = $request['page'];
            $pagesize   = 50;
            $offset     = ($pagenum - 1) * $pagesize;
            // code for pagination end
            if ($branch == '') {
                $branch_filter = '';
            } else {
                $branch_filter = " and branch ='$branch'";
            }

            if ($status == '') {
                $status_filter = '';
            } else {
                $status_filter = " and Status ='$status'";
            }

            if ($type == '') {
                $type_filter = '';
            } else {
                $type_filter = " and Beneficiery_Type ='$type'";
            }
            if ($beneficiary == '') {
                $beneficiary_filter = '';
            } else {
                $beneficiary_filter = " and Beneficiery_Name ='$beneficiary'";
            }
            if ($Comission_Period == '') {
                $com_filter = '';
            } else {
                $com_filter = "and Comission_Period = '$Comission_Period'";
            }

           
             $sql4   = "SELECT `Commission_Header_ID`,`Commission_Number`,`Comission_Period`,`Comission_Seq`,`Beneficiery_Type`,`Beneficiery_Name`,`Beneficiery_Number`,`Branch`,`Status`,Authorization_Date,Rejection_Reason,`OEM`,`PF%_Taken`,`Comission_Percentage`,ROUND(`Total_Finance_Amount`,2) AS `Total_Finance_Amount`,`No_of_Two_Wheeler`, `No_of_Two_Wheeler_New`, `No_of_Two_Wheeler_Used`, `No_of_Two_Wheeler_Refinance`, `No_of Refinance`, `No_of Personal_Loan`, `No_of Car_Loan`, `No_of Car_Loan_New`, `No_of Car_Loan_Used`, `No_of Car_Loan_Refinance`, `No_of enach_Loan`, `Total_No_Of_Cases`,ROUND( `Total_Processing_Fee`,2) as Total_Processing_Fee, `Percent_Avg_PF_Taken`, `Comm_for_Two_Wheeler`, `Comm_for Refinance`, `Comm_for Personal_Loan`, `Comm_for Car_Loan`, `Comm_for enach_Loan`, `Mobile_Reimbursement`, ROUND(`Total_Comission`,2) AS Total_Comission, `Percent_Avg_Comm_Paid`, ROUND(`Total_SGST`,2) AS Total_SGST, ROUND( `Total_CGST`,2) AS Total_CGST, ROUND( `Total_IGST`,2) AS Total_IGST,ROUND(`Total_Comm_Computed`,2) AS Total_Comm_Computed, ROUND(`TDS_Deduction`,2) AS TDS_Deduction, `Total_Balance_To_Be_Paid`, `Basic_for_OffRole` from XXBERAR_COMMISSION_HEADER where `enable` =(select max(enable) from XXBERAR_COMMISSION_HEADER) $branch_filter $com_filter $type_filter $beneficiary_filter  $status_filter order by Commission_Header_ID asc LIMIT $offset, $pagesize";
          
            $sql_count    = sprintf("SELECT  count(1) as row_count from XXBERAR_COMMISSION_HEADER where enable =(select max(enable) from XXBERAR_COMMISSION_HEADER) $branch_filter $com_filter $type_filter $beneficiary_filter $status_filter");
            $result_count = mysqli_query($this->db, $sql_count);
            while ($row1 = mysqli_fetch_assoc($result_count)) {
                $count_record = $row1['row_count'];
            }
            $result5 = mysqli_query($this->db, $sql4);
            while ($row3 = mysqli_fetch_array($result5)) {
               // $row       = array_map('utf8_encode', $row);
                $output1[] = $row3;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Branches',
                'result' => $output1,
                'create_branch' => $create_branch,
                'total_count' => $count_record
            );

            
            $this->response($this->json($out), 200);
        }
        if ($flag == 4) { //branch Lov summary
            $sql    = sprintf("SELECT DISTINCT branch FROM XXBERAR_COMMISSION_HEADER");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'branch',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }
        if ($flag == 5) { //branch Lov summary
            $sql    = sprintf("SELECT DISTINCT Beneficiery_Type FROM XXBERAR_COMMISSION_HEADER");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'BeneficieryType',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }

        if ($flag == 6) { //branch Lov summary
            $Beneficiery_Type = $request['Beneficiery_Type'];
            $branch = $request['branch'];
            if($branch == ''){
                $branch_filter ='';
            }else{
                $branch_filter = "and Branch ='$branch'";
            }
            
            $sql    = sprintf("SELECT  Beneficiery_Name FROM XXBERAR_COMMISSION_HEADER where Beneficiery_Type ='$Beneficiery_Type' $branch_filter");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'BeneficieryName',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }

        if ($flag == 7) { //branch Lov summary
            $sql    = sprintf("SELECT  distinct Comission_Period FROM XXBERAR_COMMISSION_HEADER");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'BeneficieryName',
                'result' => $output
            );
            $this->response($this->json($out), 200);
        }

        if($flag == 8){
            $Commission_Header_ID = $request['Commission_Header_ID'];
            $Rejection_Date = $request['Rejection_Date'];
            $Rejection_Reason = $request['Rejection_Reason'];
            $memo = $request['memo'];
            $Commission_Number = $request['Commission_Number'];

                 $sql_1    = sprintf("UPDATE XXBERAR_COMMISSION_HEADER SET Status='Rejected',Rejection_Date='$Rejection_Date',Rejection_Reason='$Rejection_Reason',memo='$memo',lastupdateDate=now(),lastupdateBy='$session_id' WHERE Commission_Header_ID ='$Commission_Header_ID'", mysqli_real_escape_string($this->db, $Commission_Header_ID));
                 $result_1 = mysqli_query($this->db, $sql_1);

                  $sql_4    = sprintf("UPDATE XXBERAR_LOAN_MASTER SET Comm_Processed='N' WHERE Commision_Number ='$Commission_Number'", mysqli_real_escape_string($this->db, $Commission_Number));
                   $result_4 = mysqli_query($this->db, $sql_4);


                    
                    $out      = array(
                        "status_code" => 1,
                        'status' => "Success",
                        'msg' => "Rejected Successfully",
                        'result' => "[]"
                    );
                    $this->response($this->json($out), 200);  

                   
        }

        if($flag == 9){ // bulk appprove
            $result = $request['result'];

            foreach($result as $itemm){
                $Commission_Header_ID = $itemm['Commission_Header_ID'];
                $Authorized_By = $itemm['Authorized_By'];
                $Authorization_Date = $itemm['Authorization_Date'];

                 $sql_1    = sprintf("UPDATE XXBERAR_COMMISSION_HEADER SET Status='Approved',Authorized_By='$Authorized_By',Authorization_Date='$Authorization_Date',lastupdateDate=now(),lastupdateBy='$session_id' WHERE Commission_Header_ID ='$Commission_Header_ID'", mysqli_real_escape_string($this->db, $Commission_Header_ID));
                    $result_1 = mysqli_query($this->db, $sql_1);
                   
            } 
                $out      = array(
                    "status_code" => 1,
                    'status' => "Success",
                    'msg' => "Approved Successfully",
                    'result' => "[]"
                );
                $this->response($this->json($out), 200); 
        }

        if($flag == 10){ // bulk reject
            $result = $request['result'];

            foreach($result as $itemm){
                $Commission_Header_ID = $itemm['Commission_Header_ID'];
                $Rejection_Date = $itemm['Rejection_Date'];
                $Rejection_Reason = $itemm['Rejection_Reason'];
                $Approve_Reject = $itemm['Approve_Reject'];
                $Authorized_By = $itemm['Authorized_By'];
                $Authorization_Date = $itemm['Authorization_Date'];

                $sql_1    = sprintf("UPDATE XXBERAR_COMMISSION_HEADER SET Status='$Approve_Reject',Authorized_By='$Authorized_By',Authorization_Date='$Authorization_Date',Rejection_Date='$Rejection_Date',Rejection_Reason='$Rejection_Reason',lastupdateDate=now(),lastupdateBy='$session_id' WHERE Commission_Header_ID ='$Commission_Header_ID'", mysqli_real_escape_string($this->db, $Commission_Header_ID));
                $result_1 = mysqli_query($this->db, $sql_1);
                   
            } 
            $out      = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => "updated Successfully",
                'result' => "[]"
            );
            $this->response($this->json($out), 200);  
        }

        if ($flag == 12) {
            $sql    = sprintf("SELECT 	recordID,lovValues from  XXBERAR_LOV_TYPE where lovHeadID=6 and status =1");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'StatusType',
                'result' => $output,
                'create_acess' => $create_acess
            );
            $this->response($this->json($out), 200);
        }

        if ($flag == 13) {
            $Beneficiery_Name = $request['Beneficiery_Name'];

            $sql    = sprintf("SELECT INTERNALID,VENDOR_NAME from XXBERAR_VENDOR_MASTER where PARENT_VENDOR_NAME='$Beneficiery_Name' and FLAG ='1'");
            $result = mysqli_query($this->db, $sql);
            while ($row = mysqli_fetch_assoc($result)) {
                $row      = array_map('utf8_encode', $row);
                $output[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'Sub Dealer',
                'result' => $output,
                'create_acess' => $create_acess
            );
            $this->response($this->json($out), 200);
        }
		
    }

    protected function getSettings($request)
    {
        //$this->Idlecapture($_SESSION['token'],$_SESSION['recordID']);
        
        $Schedule   = $request['Schedule'];
        $mobReimburse   = $request['mobReimburse'];
        $recordID   = $request['recordID'];
       
        $session_id         = $_SESSION['recordID'];
        $sql                = sprintf("SELECT lovValues from  XXBERAR_LOV_TYPE where recordID='$subRoleId'");
        //echo $sql;
        $result             = mysqli_query($this->db, $sql);
        while ($row = mysqli_fetch_array($result)) {
            $row          = array_map('utf8_encode', $row);
            $subRoleValue = $row['lovValues'];
        }
        $session_prev   = $_SESSION['recordID'];
        $subRoleID      = $_SESSION['subRole'];
        $previlege_find = "select previlage from (SELECT xua.recordID, xar.subRoleID, xar.privilegeID,(SELECT lovValues
				FROM XXBERAR_LOV_TYPE
				WHERE recordID = xar.privilegeID
				)lovValues,xua.managerPrivilege,xua.buyerPrivilege,xua.adminPrivilege, 
				greatest(CASE WHEN(xua.managerPrivilege = 1) THEN xar.managerAccess ELSE 0 END,
						 CASE WHEN(xua.buyerPrivilege = 1) THEN xar.buyerAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 1) THEN xar.adminAccess ELSE 0 END,
						 CASE WHEN(xua.adminPrivilege = 0 and xua.buyerPrivilege = 0 and xua.managerPrivilege = 0) THEN xar.	noPrivilegeAccess ELSE 0 END) previlage
				From XXTATA_SP_USER_SETUP xua, XXTATA_SP_ACCESS_RIGHTS xar
				Where
					 xar.subRoleID= xua.subRole
				 and xua.recordID='$session_prev')f where f.lovValues='ARTIFACTS' ";
        //echo $previlege_find;
        $result_find    = mysqli_query($this->db, $previlege_find);
        while ($row = mysqli_fetch_array($result_find)) {
            $row       = array_map('utf8_encode', $row);
            $previlage = $row['previlage'];
        }
        if ($previlage == '2') {
            $create_branch = 1;
            $save_artifact = 1;
        } else {
            $create_branch = 0;
            $save_artifact = 0;
        }
        $flag = $request['flag'];

            
        if( $flag == 1){

           $sql_1    = sprintf("UPDATE XXTATA_SP_SETTINGS SET Schedule='$Schedule',mobReimburse='$mobReimburse',lastupdateDate=now(),lastupdateBy='$session_id' WHERE recordID ='$recordID'", mysqli_real_escape_string($this->db, $recordID));
            $result_1 = mysqli_query($this->db, $sql_1);
            $out      = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => "updated Successfully",
                'result' => "[]"
            );
            $this->response($this->json($out), 200);  
        }
        if ($flag == 2) {

            $sql1     = sprintf("SELECT recordID,Schedule,mobReimburse from XXTATA_SP_SETTINGS");
            $result1  = mysqli_query($this->db, $sql1);
            while ($row = mysqli_fetch_assoc($result1)) {
                
                $row       = array_map('utf8_encode', $row);
                $output1[] = $row;
            }
            $out = array(
                "status_code" => 1,
                'status' => "Success",
                'msg' => 'settings',
                'result' => $output1,
                'save_artifact' => $save_artifact
            );
            $this->response($this->json($out), 200);
        }
	
    }

    public function logoutUser()
    {
        if (isset($_SESSION['userID'])) {
            $log = array(
                "status_code" => 0,
                'status' => "Success",
                "msg" => "Logged-out Successfully.",
                "sess" => $_SESSION['userID']
            );
            unset($_SESSION['token']);
            session_unset(); // unset $_SESSION variable for the run-time
            session_destroy(); // destroy session data in storage
            $error = array(
                "status_code" => 0,
                'status' => "Success",
                "msg" => "Logged-out Successfully. "
            );
            $this->response($this->json($error), 200);
        } else {
            $log   = array(
                "status_code" => 0,
                'status' => "Success",
                "msg" => "Session already expired."
            );
            //log_info($this->json($log));
            $error = array(
                "status_code" => 0,
                'status' => "Success",
                "msg" => "Logged-out Successfully"
            );
            $this->response($this->json($error), 200);
        }
    }
}
